package com.cntomorrow.entity.android.tj_yd.service;

package ..deTemp.1732183162158;

import com.cntomorrow.core.other.sql.SpringProcedure;
import com.cntomorrow.entity.android.tj_yd.dao.GjjxPanelDao;
import com.cntomorrow.entity.android.tj_yd.entity.FgqEntity;
import com.cntomorrow.entity.android.tj_yd.entity.FgqInfoBean;
import com.cntomorrow.entity.android.tj_yd.entity.GjjxPanel;
import com.cntomorrow.entity.android.tj_yd.entity.GjjxPort;
import com.cntomorrow.entity.android.tj_yd.entity.ResultBean;
import com.cntomorrow.entity.android.tj_yd.entity.RowInfo;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.support.rowset.SqlRowSet;
import org.springframework.stereotype.Service;

@Service
public class GjjxPanelService {
  @Autowired
  private GjjxPanelDao gjjxPanelDao;
  
  public GjjxPanel findGjjxPortInfo(String flag, String devfldid, String devfldtag) {
    GjjxPanel panel = new GjjxPanel();
    if (!"".equals(devfldid) && devfldid != null && !"".equals(devfldtag) && devfldtag != null && !"".equals(flag) && flag != null) {
      String tableName = "";
      String ptableName = "";
      if ("001004001056006".equals(devfldtag)) {
        tableName = "tld_device_opt";
        ptableName = "tld_port_opt";
      } else if ("0010040010560061".equals(devfldtag)) {
        tableName = "tldd_device_opt";
        ptableName = "tldd_port_opt";
      } 
      if (!"".equals(tableName) && !"".equals(ptableName)) {
        SqlRowSet gjjxRs = this.gjjxPanelDao.queryGjjxName(tableName, devfldtag, devfldid);
        int row = 0;
        int col = 0;
        if (gjjxRs.next()) {
          panel.setFldname(String.valueOf(gjjxRs.getString("fldname")) + flag + "面");
          if ("A".equals(flag)) {
            panel.setRows(gjjxRs.getString("arows"));
            panel.setCols(gjjxRs.getString("acols"));
            row = gjjxRs.getInt("arows");
            col = gjjxRs.getInt("acols");
          } else {
            panel.setRows(gjjxRs.getString("brows"));
            panel.setCols(gjjxRs.getString("bcols"));
            row = gjjxRs.getInt("brows");
            col = gjjxRs.getInt("bcols");
          } 
        } 
        List<GjjxPort> portData = null;
        try {
          portData = queryPortInfo(devfldid, devfldtag, flag, ptableName);
          int datanum = portData.size();
          if (portData != null && datanum > 0) {
            int num = row * col;
            if (num != datanum) {
              panel.setResult("0");
              panel.setErrorMsg("存在名称不规则的端子,无法展示！");
            } else {
              panel.setPortList(portData);
              List<List<RowInfo>> rowInfo = getRowInfo(ptableName, portData, row, col);
              panel.setRowInfo(rowInfo);
              panel.setResult("1");
              panel.setErrorMsg("");
            } 
          } else {
            panel.setResult("0");
            panel.setErrorMsg("光交接箱端子信息为空！");
          } 
        } catch (Exception e) {
          panel.setResult("0");
          panel.setErrorMsg("端子信息查询有误！");
          e.printStackTrace();
        } 
      } else {
        panel.setResult("0");
        panel.setErrorMsg("光交接箱Tag不匹配!");
      } 
    } else {
      panel.setResult("0");
      panel.setErrorMsg("光交接箱ID或Tag为空！");
    } 
    return panel;
  }
  
  private List<List<RowInfo>> getRowInfo(String ptableName, List<GjjxPort> portData, int row, int col) throws Exception {
    List<List<RowInfo>> rowinfList = new ArrayList<List<RowInfo>>();
    for (int i = 0; i < row; i++) {
      List<GjjxPort> rowPorts = new ArrayList<GjjxPort>();
      for (int j = 0; j < col; j++) {
        GjjxPort port = portData.get(i * col + j);
        rowPorts.add(port);
      } 
      List<RowInfo> rowinfs = getRowPortsInf(ptableName, rowPorts);
      rowinfList.add(rowinfs);
    } 
    return rowinfList;
  }
  
  private List<RowInfo> getRowPortsInf(String ptableName, List<GjjxPort> rowPorts) throws Exception {
    List<RowInfo> rowinfs = new ArrayList<RowInfo>();
    StringBuffer inids = new StringBuffer();
    for (int i = 0; i < rowPorts.size(); i++) {
      inids.append("'" + ((GjjxPort)rowPorts.get(i)).getFldid() + "'");
      if (i < rowPorts.size() - 1)
        inids.append(","); 
    } 
    SqlRowSet rs = this.gjjxPanelDao.getGjjxPortInfo(ptableName, inids.toString());
    while (rs.next()) {
      String fldportids = rs.getString("fldportids");
      String fldshare = rs.getString("fldshare");
      String fldshowname = rs.getString("fldshowname");
      System.out.println("-- fldshowname:" + fldshowname + " fldshare:" + fldshare);
      if (!"-1".equals(fldshowname)) {
        fldshowname = getFinalShowName(fldshowname, fldportids, rowPorts);
        rowinfs.add(new RowInfo(fldshare, fldshowname));
        System.out.println("getRowPortsInf=== fldshare:" + fldshare + " fldshowname:" + fldshowname);
      } 
    } 
    List<RowInfo> sortRowinfs = new ArrayList<RowInfo>();
    Map<Integer, Integer> numsort = new HashMap<Integer, Integer>();
    List<Integer> numlist = new ArrayList<Integer>();
    String mshowname = "";
    int portnum = 0;
    for (int j = 0; j < rowinfs.size(); j++) {
      mshowname = ((RowInfo)rowinfs.get(j)).getShowname();
      if (mshowname.startsWith("("))
        try {
          portnum = Integer.parseInt(mshowname.substring(mshowname.indexOf("(") + 1, mshowname.indexOf("-")));
          System.out.println(portnum);
          numsort.put(Integer.valueOf(portnum), Integer.valueOf(j));
          numlist.add(Integer.valueOf(portnum));
        } catch (Exception e) {
          e.printStackTrace();
        }  
    } 
    if (!numsort.isEmpty()) {
      Collections.sort(numlist);
      for (Integer pnum : numlist)
        sortRowinfs.add(rowinfs.get(((Integer)numsort.get(pnum)).intValue())); 
    } else {
      sortRowinfs = rowinfs;
    } 
    return sortRowinfs;
  }
  
  private String getFinalShowName(String fldshowname, String fldportids, List<GjjxPort> rowPorts) throws Exception {
    String finalName = "";
    String[] ports = fldportids.split(",");
    if (ports.length == rowPorts.size())
      return fldshowname; 
    List<String> portList = new ArrayList<String>();
    for (int i = 0; i < ports.length; i++)
      portList.add(ports[i]); 
    List<Integer> indexlist = new ArrayList<Integer>();
    for (int j = 0; j < rowPorts.size(); j++) {
      if (portList.contains(((GjjxPort)rowPorts.get(j)).getFldid()))
        indexlist.add(Integer.valueOf(j + 1)); 
    } 
    int m = 0;
    int n = 0;
    int lastnum = 0;
    StringBuffer shownum = new StringBuffer();
    for (int k = 0; k < indexlist.size(); k++) {
      m = ((Integer)indexlist.get(k)).intValue();
      if (k == 0) {
        lastnum = m;
        shownum.append((new StringBuilder(String.valueOf(m))).toString());
      } 
      if (k > 0) {
        n = ((Integer)indexlist.get(k - 1)).intValue();
        if (m == n + 1) {
          if (k == indexlist.size() - 1)
            shownum.append("-" + m); 
        } else {
          if (lastnum < n)
            shownum.append("-" + n); 
          shownum.append(",");
          if (k == indexlist.size() - 1)
            shownum.append((new StringBuilder(String.valueOf(m))).toString()); 
          lastnum = n;
        } 
      } 
    } 
    finalName = "(" + shownum.toString() + ")" + fldshowname;
    return finalName;
  }
  
  public List<GjjxPort> queryPortInfo(String devfldid, String devfldtag, String flag, String ptableName) throws Exception {
    List<GjjxPort> list = new ArrayList<GjjxPort>();
    String porttag = "";
    String tortableNmae = "";
    String tortag = "";
    String tlotableName = "";
    String tlotag = "";
    if ("tld_port_opt".equals(ptableName)) {
      porttag = "001004002020";
      tortableNmae = "tgx_optseg_rack";
      tortag = "001009003023";
      tlotableName = "tld_link_optcore";
      tlotag = "001005001002";
    } else {
      porttag = "0010040020201";
      tortableNmae = "tgxd_optseg_rack";
      tortag = "0010090030231";
      tlotableName = "tldd_link_optcore";
      tlotag = "0010050010021";
    } 
    SqlRowSet portRs = this.gjjxPanelDao.queryPortInfo(ptableName, porttag, devfldid, devfldtag, flag);
    while (portRs.next()) {
      GjjxPort port = new GjjxPort();
      String fldid = portRs.getString("fldid");
      String fldtag = portRs.getString("fldtag");
      port.setFldid(fldid);
      port.setFldtag(fldtag);
      String cportname = portRs.getString("fldcportname").substring(1);
      port.setFldcportname(cportname);
      String hasLink = portRs.getString("HASLINK");
      String pstatus = portRs.getString("fldstatus");
      if ("0".equals(hasLink) && 
        "1".equals(pstatus))
        pstatus = "100"; 
      port.setFldstatus(pstatus);
      port.setFldisdesign(portRs.getString("fldisdesign"));
      SqlRowSet tloRs = this.gjjxPanelDao.queryTldLinkOptcore(tlotableName, fldid, fldtag, tlotag);
      String tofldstatus = "";
      String tofldisdesign = "";
      String testStatus = "b_gray";
      if (tloRs.next()) {
        String fg = "";
        String tofldid = "";
        String tofldtag = "";
        String id = tloRs.getString("fldaportid");
        String tag = tloRs.getString("fldaporttag");
        testStatus = tloRs.getString("fldteststatus");
        if (("".equals(id) && id == null) || ("".equals(tag) && tag == null)) {
          SqlRowSet torRs = this.gjjxPanelDao.queryTgxOptsegRack(tortableNmae, fldid, fldtag, tortag);
          if (torRs.next()) {
            tofldid = torRs.getString("termid");
            tofldtag = torRs.getString("termtag");
          } 
        } else {
          if (fldid.equals(id) && fldtag.equals(tag)) {
            fg = "b";
          } else {
            fg = "a";
          } 
          tofldid = tloRs.getString("fld" + fg + "portid");
          tofldtag = tloRs.getString("fld" + fg + "porttag");
        } 
        String tableName = "";
        if ("001004002020".equals(tofldtag)) {
          tableName = "TLD_PORT_OPT";
        } else if ("0010040020201".equals(tofldtag)) {
          tableName = "TLDD_PORT_OPT";
        } else {
          tableName = "TLD_PORT";
        } 
        SqlRowSet toPortRs = this.gjjxPanelDao.queryToPortInfo(tableName, tofldid, tofldtag);
        if (toPortRs.next()) {
          tofldstatus = toPortRs.getString("tofldstatus");
          tofldisdesign = toPortRs.getString("tofldisdesign");
        } 
      } 
      port.setTofldstatus(tofldstatus);
      port.setTofldisdesign(tofldisdesign);
      String classname = getPortClass(pstatus, testStatus);
      port.setFldclass(classname);
      list.add(port);
    } 
    return list;
  }
  
  private String getPortClass(String portstatus, String testStatus) {
    String classname = "b_gray";
    if (portstatus != null && portstatus != "") {
      if (testStatus != null && testStatus != "") {
        if (portstatus.equals("2")) {
          if (testStatus.equals("2") || testStatus.equals("4")) {
            classname = "b_red";
          } else if (testStatus.equals("1") || testStatus.equals("3")) {
            classname = "b_orange";
          } 
        } else if (portstatus.equals("1")) {
          if (testStatus.equals("2")) {
            classname = "b_yellow";
          } else if (testStatus.equals("1") || testStatus.equals("1")) {
            classname = "b_green";
          } else {
            classname = "b_gray";
          } 
        } else if (portstatus.equals("100")) {
          classname = "b_gray";
        } else if (testStatus.equals("2") || testStatus.equals("4")) {
          classname = "b_yellow";
        } else if (testStatus.equals("1") || testStatus.equals("3")) {
          classname = "b_orange";
        } 
      } else if (portstatus.equals("1")) {
        classname = "b_green";
      } else if (portstatus.equals("2")) {
        classname = "b_red";
      } else if (portstatus.equals("100")) {
        classname = "b_gray";
      } else {
        classname = "b_yellow";
      } 
    } else {
      classname = "b_green";
    } 
    return classname;
  }
  
  public FgqInfoBean findFgqListInfo(String gjjxid, String gjjxtag) {
    FgqInfoBean bean = new FgqInfoBean();
    if (!"".equals(gjjxid) && gjjxid != null && !"".equals(gjjxtag) && gjjxtag != null) {
      List<FgqEntity> list = new ArrayList<FgqEntity>();
      SqlRowSet fgqRs = this.gjjxPanelDao.queryFgqListInfo(gjjxid, gjjxtag);
      while (fgqRs.next()) {
        FgqEntity entity = new FgqEntity();
        entity.setFldid(fgqRs.getString("fldid"));
        entity.setFldtag(fgqRs.getString("fldtag"));
        entity.setFldname(fgqRs.getString("fldname"));
        list.add(entity);
      } 
      bean.setFgqList(list);
      bean.setResult("1");
      bean.setErrorMsg("");
    } else {
      bean.setResult("0");
      bean.setErrorMsg("光交接箱ID或Tag为空!");
    } 
    return bean;
  }
  
  public ResultBean updatePortLinkInfo(String vEntityTag, String vEntityID, String vNewValue) {
    ResultBean bean = new ResultBean();
    String pkgName = "PKG_RCT_IDATA.SP_MODIFY_CONNSTATE";
    String sResult = "";
    SpringProcedure optDataSP = new SpringProcedure(pkgName, 4);
    optDataSP.addParameter(1, 12, "vEntityTag", vEntityTag);
    optDataSP.addParameter(1, 12, "vEntityID", vEntityID);
    optDataSP.addParameter(1, 12, "vNewValue", vNewValue);
    optDataSP.addParameter(2, 12, "sResult", sResult);
    try {
      optDataSP.execute();
      sResult = optDataSP.getParameterValue("sResult");
      if ("1".equals(sResult)) {
        bean.setResult("1");
        bean.setRstMsg("");
      } else {
        bean.setResult("0");
        bean.setRstMsg(sResult);
      } 
    } catch (Exception e) {
      bean.setResult("0");
      bean.setRstMsg("后台服务器数据异常!");
      e.printStackTrace();
    } 
    return bean;
  }
  
  public ResultBean queryBusinessInfo(String business1, String business2) {
    ResultBean bean = new ResultBean();
    String businessName1 = null;
    String businessName2 = null;
    if (business1 != null && !"".equals(business1))
      try {
        SqlRowSet rst1 = this.gjjxPanelDao.checkBussinessInfo(business1);
        if (rst1.next())
          businessName1 = rst1.getString("fldname"); 
      } catch (Exception e) {
        bean.setResult("0");
        bean.setRstMsg("查询端子业务信息异常!");
        e.printStackTrace();
      }  
    if (business2 != null && !"".equals(business2))
      try {
        SqlRowSet rst2 = this.gjjxPanelDao.checkBussinessInfo(business2);
        if (rst2.next())
          businessName2 = rst2.getString("fldname"); 
      } catch (Exception e) {
        bean.setResult("0");
        bean.setRstMsg("查询端子业务信息异常!");
        e.printStackTrace();
      }  
    if (businessName1 != null || businessName2 != null) {
      bean.setBusinessName1(businessName1);
      bean.setBusinessName2(businessName2);
      bean.setResult("1");
      bean.setRstMsg("");
    } else {
      bean.setResult("0");
      bean.setRstMsg("所选两端子业务信息均为空，不允许置换!");
    } 
    return bean;
  }
  
  public ResultBean updateBusinessInfo(String business1, String business2) {
    ResultBean bean = new ResultBean();
    String[] vAStr = business1.split("###");
    String[] vBStr = business2.split("###");
    String vAEntityTag = vAStr[0];
    String vAEntityID = vAStr[1];
    String vBEntityTag = vBStr[0];
    String vBEntityID = vBStr[1];
    String sResult = "";
    String pkgName = "PKG_RCT_IDATA.SP_CHANGE_BUSI";
    SpringProcedure optDataSP = new SpringProcedure(pkgName, 5);
    optDataSP.addParameter(1, 12, "vAEntityTag", vAEntityTag);
    optDataSP.addParameter(1, 12, "vAEntityID", vAEntityID);
    optDataSP.addParameter(1, 12, "vBEntityTag", vBEntityTag);
    optDataSP.addParameter(1, 12, "vBEntityID", vBEntityID);
    optDataSP.addParameter(2, 12, "sResult", sResult);
    try {
      optDataSP.execute();
      sResult = optDataSP.getParameterValue("sResult");
      if ("1".equals(sResult)) {
        bean.setResult("1");
        bean.setRstMsg("端子业务信息置换成功!");
      } else {
        bean.setResult("0");
        bean.setRstMsg(sResult);
      } 
    } catch (Exception e) {
      bean.setResult("0");
      bean.setRstMsg("后台服务器数据处理异常!");
      e.printStackTrace();
    } 
    return bean;
  }
  
  public void writeLog(List<String> writeSql) {
    if (writeSql.size() == 2) {
      String fldid = this.gjjxPanelDao.getFldid("S012");
      String sql = ((String)writeSql.get(0)).replace("?", "'" + fldid + "'");
      System.out.println("日志记录sql(1)--" + sql);
      if (this.gjjxPanelDao.executeSql(sql)) {
        sql = ((String)writeSql.get(1)).replace("?", "'" + fldid + "'");
        System.out.println("日志记录sql(2)--" + sql);
        this.gjjxPanelDao.executeSql(sql);
      } 
    } 
  }
}
